Bug 966703 - Closing session that created exclusive queue does not alter QMF object for the queue as non-exclusive
Closing session that created exclusive queue does not alter QMF object for th...
Status: POST
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: qpid-cpp (Show other bugs)
2.3
All All
medium Severity medium
: ---
: ---
Assigned To: Gordon Sim
MRG Quality Engineering
: EasyFix, Patch, TestCaseProvided
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-05-23 13:51 EDT by Pavel Moravec
Modified: 2016-03-28 18:40 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Trivial patch proposal (528 bytes, patch)
2013-05-24 06:23 EDT, Pavel Moravec
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Apache JIRA QPID-4178 None None None Never

  None (edit)
Description Pavel Moravec 2013-05-23 13:51:07 EDT
Description of problem:
When a session creates an exclusive queue and then the session is closed, the queue is / should be marked as non-exclusive. While a consumer can subscribe to such queue (meaning the queue really isnt exclusive), qpid tools still show the queue as exclusive.

The reason is when cancelling the queue subscription, exclusive flag is reset properly but relevant QMF object isn't updated (see patch).


Version-Release number of selected component (if applicable):
0.18-14 (seems to be in upstream = 0.22 as well)


How reproducible:
100%


Steps to Reproduce:
1. Create an exclusive queue, and release all subscribers
/usr/share/doc/python-qpid-0.18/examples/api/drain "MyQueue; {create:receiver, node:{ x-declare:{ exclusive:true}}}"

2. check the queue exclusivity
qpid-config queues


Actual results:
# qpid-config queues
Queue Name                                Attributes
=================================================================
MyQueue                                   excl 
ae4588ea-6ddf-446c-a235-8073c1d83ace:0.0  auto-del excl 
#


Expected results:
# qpid-config queues
Queue Name                                Attributes
=================================================================
MyQueue                                    
ae4588ea-6ddf-446c-a235-8073c1d83ace:0.0  auto-del excl 
#


Additional info:
Patch to be provided.
Comment 2 Pavel Moravec 2013-05-24 06:23:52 EDT
Created attachment 752532 [details]
Trivial patch proposal

When releasing exclusive ownership of a queue, relevant QMF management object has to unset exclusive flag.
Comment 4 Pavel Moravec 2013-05-24 06:30:37 EDT
Btw. upstream has already fixed this in revision 1371676 (per http://svn.apache.org/viewvc/qpid/trunk/qpid/cpp/src/qpid/broker/Queue.cpp?view=annotate and Queue::releaseExclusiveOwnership() method there).
Comment 5 Justin Ross 2013-05-24 08:10:17 EDT
I moved this to POST, but it may end up needing a narrower backport.
Comment 6 Mike McCune 2016-03-28 18:40:27 EDT
This bug was accidentally moved from POST to MODIFIED via an error in automation, please see mmccune@redhat.com with any questions

Note You need to log in before you can comment on or make changes to this bug.